Index: /simplerunner/src/test/java/geniusweb/simplerunner/SessionRunnerE2ETest.java
===================================================================
--- /simplerunner/src/test/java/geniusweb/simplerunner/SessionRunnerE2ETest.java	(revision 20)
+++ /simplerunner/src/test/java/geniusweb/simplerunner/SessionRunnerE2ETest.java	(revision 21)
@@ -1,3 +1,5 @@
 package geniusweb.simplerunner;
+
+import static org.junit.Assert.assertTrue;
 
 import java.io.IOException;
@@ -27,4 +29,5 @@
 @RunWith(Parameterized.class)
 public class SessionRunnerE2ETest {
+	private static final int TEST_RUNTIME = 5000;
 	private final ObjectMapper jackson = new ObjectMapper();
 	private NegoRunner runner;
@@ -37,5 +40,6 @@
 				.asList(new Object[][] { { "src/test/resources/settings.json" },
 						{ "src/test/resources/settings2.json" },
-						{ "src/test/resources/shaoptoursettings.json" } });
+						{ "src/test/resources/shaoptoursettings.json" },
+						{ "src/test/resources/mopac.json" } });
 	}
 
@@ -53,5 +57,5 @@
 
 		runner = new NegoRunner(settings, new ClassPathConnectionFactory(),
-				logger);
+				logger, TEST_RUNTIME);
 
 	}
@@ -64,4 +68,6 @@
 	public void runTest() throws IOException {
 		runner.run();
+		assertTrue(runner.isProperlyStopped());
+		System.out.println("Final state:\n" + runner.getProtocol().getState());
 	}
 
Index: /simplerunner/src/test/java/geniusweb/simplerunner/SessionRunnerTest.java
===================================================================
--- /simplerunner/src/test/java/geniusweb/simplerunner/SessionRunnerTest.java	(revision 20)
+++ /simplerunner/src/test/java/geniusweb/simplerunner/SessionRunnerTest.java	(revision 21)
@@ -16,4 +16,5 @@
 import org.mockito.ArgumentCaptor;
 
+import geniusweb.actions.PartyId;
 import geniusweb.protocol.CurrentNegoState;
 import geniusweb.protocol.NegoState;
@@ -29,5 +30,5 @@
 public class SessionRunnerTest {
 	private static final ProtocolException PROTOCOL_EXC = new ProtocolException(
-			"fake protocol exception", "test");
+			"fake protocol exception", new PartyId("test"));
 	private CurrentNegoState finishedEvent;
 	private final long NOW = 1000;
@@ -47,5 +48,5 @@
 	public void smokeTest() {
 		new NegoRunner(mock(SessionSettings.class),
-				mock(ProtocolToPartyConnFactory.class), logger);
+				mock(ProtocolToPartyConnFactory.class), logger, 5000);
 	}
 
@@ -59,5 +60,6 @@
 				ProtocolToPartyConnFactory.class);
 
-		NegoRunner runner = spy(new NegoRunner(settings, factory, logger));
+		NegoRunner runner = spy(
+				new NegoRunner(settings, factory, logger, 5000));
 		runner.run();
 
@@ -75,5 +77,4 @@
 		when(settings.getProtocol(any())).thenReturn(protocol);
 		SessionState state = mock(SessionState.class);
-		when(state.getError()).thenReturn(null);
 		when(protocol.getState()).thenReturn(state);
 		Reporter logger = mock(Reporter.class);
@@ -81,10 +82,11 @@
 		ProtocolToPartyConnFactory factory = mock(
 				ProtocolToPartyConnFactory.class);
-		NegoRunner runner = spy(new NegoRunner(settings, factory, logger) {
-			@Override
-			protected void logFinal(Level level, NegoState state) {
-				log.log(level, state.toString());
-			}
-		});
+		NegoRunner runner = spy(
+				new NegoRunner(settings, factory, logger, 5000) {
+					@Override
+					protected void logFinal(Level level, NegoState state) {
+						log.log(level, state.toString());
+					}
+				});
 		ArgumentCaptor<Listener> listener = ArgumentCaptor
 				.forClass(Listener.class);
@@ -107,15 +109,15 @@
 		when(settings.getProtocol(any())).thenReturn(protocol);
 		SessionState state = mock(SessionState.class);
-		when(state.getError()).thenReturn(PROTOCOL_EXC);
 		when(protocol.getState()).thenReturn(state);
 		@SuppressWarnings("unchecked")
 		ProtocolToPartyConnFactory factory = mock(
 				ProtocolToPartyConnFactory.class);
-		NegoRunner runner = spy(new NegoRunner(settings, factory, logger) {
-			@Override
-			protected void logFinal(Level level, NegoState state) {
-				log.log(level, state.toString());
-			}
-		});
+		NegoRunner runner = spy(
+				new NegoRunner(settings, factory, logger, 5000) {
+					@Override
+					protected void logFinal(Level level, NegoState state) {
+						log.log(level, state.toString());
+					}
+				});
 		ArgumentCaptor<Listener> listener = ArgumentCaptor
 				.forClass(Listener.class);
@@ -126,6 +128,8 @@
 		listener.getValue().notifyChange(finishedEvent);
 		verify(runner, times(1)).stop();
-		// check that the protocol error is logged properly
-		verify(logger, times(1)).log(eq(Level.WARNING), any(String.class));
+		// check final state is logged
+		String statestr = state.toString();
+		verify(logger, times(1)).log(any(), eq(statestr));
+
 	}
 
Index: /voting/src/main/java/geniusweb/voting/CollectedVotes.java
===================================================================
--- /voting/src/main/java/geniusweb/voting/CollectedVotes.java	(revision 21)
+++ /voting/src/main/java/geniusweb/voting/CollectedVotes.java	(revision 21)
@@ -0,0 +1,275 @@
+package geniusweb.voting;
+
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.List;
+import java.util.Map;
+import java.util.Set;
+import java.util.stream.Collectors;
+
+import geniusweb.actions.PartyId;
+import geniusweb.actions.Vote;
+import geniusweb.actions.Votes;
+import geniusweb.issuevalue.Bid;
+import tudelft.utilities.immutablelist.FixedList;
+import tudelft.utilities.immutablelist.ImmutableList;
+import tudelft.utilities.immutablelist.PowerSet;
+
+/**
+ * Utility class. Typically contains all the votes collected from 1 round. Can
+ * find the best combinations of votes, eg to get the maximum consensus group
+ */
+public class CollectedVotes {
+	private final Map<PartyId, Votes> allvotes;
+	private final Map<PartyId, Integer> powers;
+
+	// caching
+	private transient Map<Bid, Set<Vote>> allBids = null;
+
+	/**
+	 * 
+	 * @param votesMap the {@link Votes} done for each party
+	 * @param power  the power of each party. The power is an integer number. In
+	 *               the voting process, the party powers add up to form the
+	 *               total voting power. This set may contain parties that are
+	 *               not in newmap.
+	 */
+	public CollectedVotes(Map<PartyId, Votes> votesMap,
+			Map<PartyId, Integer> power) {
+		this.allvotes = new HashMap<>(votesMap);
+		this.powers = new HashMap<>(power);
+		if (!powers.keySet().containsAll(allvotes.keySet())) {
+			throw new IllegalArgumentException(
+					"All voting parties must have a power");
+		}
+	}
+
+	/**
+	 * @param votes additional set of votes for a new party that did not yet
+	 *              vote.
+	 * @param power powers for the new party, can be null if power already set
+	 *              previously.
+	 * @return new CollectedVotes with the new votes added.
+	 */
+	public CollectedVotes with(Votes votes, Integer power) {
+		PartyId actor = votes.getActor();
+		if (allvotes.containsKey(actor))
+			throw new IllegalArgumentException(
+					"Party " + actor + " already voted");
+
+		Map<PartyId, Integer> newpowers = new HashMap<>(powers);
+		if (!powers.containsKey(actor)) {
+			if (power == null)
+				throw new IllegalArgumentException(
+						"Power must be set for new actor " + actor);
+			newpowers.put(actor, power);
+		}
+
+		Map<PartyId, Votes> newmap = new HashMap<>(allvotes);
+		newmap.put(actor, votes);
+		return new CollectedVotes(newmap, newpowers);
+	}
+
+	/**
+	 * @return all the votes placed so far
+	 */
+	public Map<PartyId, Votes> getVotes() {
+		return Collections.unmodifiableMap(allvotes);
+	}
+
+	/**
+	 * @return the powers of all parties
+	 */
+	public Map<PartyId, Integer> getPowers() {
+		return Collections.unmodifiableMap(powers);
+	}
+
+	/**
+	 * @return a hashmap containing the {@link Bid}s and a maximum-sized list of
+	 *         {@link PartyId}s that placed a satisfied vote for that bid.
+	 *         maximum-sized means that there is no larger subset of satisfied
+	 *         votes for that bid. There may be other subsets of equal size for
+	 *         the bid. If there are no agreements at all for a bid, the bid is
+	 *         not placed in the map.
+	 */
+	public Map<Bid, Set<PartyId>> getMaxAgreements() {
+		Map<Bid, Set<PartyId>> agreements = new HashMap<>();
+		Map<Bid, Set<Vote>> allbidsmap = getAllBids();
+		for (Bid bid : allbidsmap.keySet()) {
+			Set<PartyId> max = getMaxPowerGroup(allbidsmap.get(bid));
+			if (!max.isEmpty())
+				agreements.put(bid, max);
+		}
+		return agreements;
+	}
+
+	/**
+	 * @return all bids that were voted on and the votes for that bid. This
+	 *         basically reverses keys and values in {@link #allvotes}
+	 */
+	public Map<Bid, Set<Vote>> getAllBids() {
+		if (allBids == null)
+			allBids = getAllBids1();
+		return allBids;
+	}
+
+	/**
+	 * 
+	 * @param parties the parties to be removed
+	 * @return new CollectedVotes without given parties
+	 */
+	public CollectedVotes without(Set<PartyId> parties) {
+		Map<PartyId, Votes> newvotes = new HashMap<>(allvotes);
+		newvotes.keySet().removeAll(parties);
+		Map<PartyId, Integer> newpower = new HashMap<>(powers);
+		newpower.keySet().removeAll(parties);
+		return new CollectedVotes(newvotes, newpower);
+	}
+
+	/**
+	 * 
+	 * @param votes a list of all votes for a particular bid. The parties that
+	 *              placed the votes are called 'voters'
+	 * @return a subset of the voters for which holds (1) the min-power
+	 *         condition of all these voters is satisfied (2) the power of this
+	 *         subset of voters is maximal (no other satisfied set of voters
+	 *         with bigger power exists) maximum-power that placed votes with
+	 *         holding conditions.This algorithm works in quadratic time.
+	 */
+	protected Set<PartyId> getMaxPowerGroup(Set<Vote> votes) {
+		Set<PartyId> maxgroup = Collections.emptySet();
+		Integer maxpower = 0;
+
+		for (Vote vote : votes) {
+			int target = vote.getMinPower();
+
+			// find parties that would join if we reach that power
+			Set<PartyId> group = votes.stream()
+					.filter(v -> target >= v.getMinPower())
+					.map(v -> v.getActor()).collect(Collectors.toSet());
+			// check what the group's power is
+			Integer groupPower = getTotalPower(group);
+			if (groupPower >= target && groupPower > maxpower) {
+				maxgroup = group;
+				maxpower = groupPower;
+			}
+		}
+		return maxgroup;
+	}
+
+	/**
+	 * 
+	 * @param votes a set of {@link Votes} for one single {@link Bid}
+	 * @return all the consensus groups. A consensus group is a subset of the
+	 *         votes, for which the conditions holds (the combined power of
+	 *         these parties exceeds all voting conditions) if all these parties
+	 *         as a group are accepting that bid. This algorithm works in
+	 *         exponential space and the outcome may also be exponential in the
+	 *         input size.
+	 */
+	protected Set<Set<PartyId>> getConsensusGroups(List<Vote> votes) {
+		Set<Set<PartyId>> groups = new HashSet<>();
+
+		PowerSet<Vote> allVotePermutations = new PowerSet<Vote>(
+				new FixedList<Vote>(votes));
+		// check each possible subset.
+		for (ImmutableList<Vote> voteList : allVotePermutations) {
+			Set<PartyId> parties = getParties(voteList);
+			if (parties.size() >= 2
+					&& getTotalPower(parties) >= getMinPower(voteList)) {
+				groups.add(parties);
+			}
+		}
+		return groups;
+	}
+
+	/**
+	 * @param voteList
+	 * @return all parties that did a vote
+	 */
+	public static Set<PartyId> getParties(ImmutableList<Vote> voteList) {
+		Set<PartyId> parties = new HashSet<>();
+		for (Vote vote : voteList) {
+			parties.add(vote.getActor());
+		}
+		return parties;
+	}
+
+	/**
+	 * 
+	 * @param votes a list of {@link Vote}s on one Bid. All parties must be
+	 *              known
+	 * @return the minimum voting power needed for this group, so that all can
+	 *         accept. This is equal to the max of the vote.getMinPower
+	 */
+	private Integer getMinPower(ImmutableList<Vote> votes) {
+		int max = 0;
+		for (Vote vote : votes) {
+			max = Math.max(max, vote.getMinPower());
+		}
+		return max;
+	}
+
+	/**
+	 * 
+	 * @param parties a list of parties
+	 * @return total voting power of the parties
+	 */
+	private Integer getTotalPower(Set<PartyId> parties) {
+		return parties.stream().map(p -> powers.get(p)).reduce(0, Integer::sum);
+	}
+
+	private Map<Bid, Set<Vote>> getAllBids1() {
+		Map<Bid, Set<Vote>> bids = new HashMap<>();
+		for (Votes votes : allvotes.values()) {
+			for (Vote vote : votes.getVotes()) {
+				Bid bid = vote.getBid();
+				Set<Vote> list = bids.get(bid);
+				if (list == null)
+					list = new HashSet<Vote>();
+				list.add(vote);
+				bids.put(bid, list);
+			}
+		}
+		return bids;
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result
+				+ ((allvotes == null) ? 0 : allvotes.hashCode());
+		result = prime * result + ((powers == null) ? 0 : powers.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		CollectedVotes other = (CollectedVotes) obj;
+		if (allvotes == null) {
+			if (other.allvotes != null)
+				return false;
+		} else if (!allvotes.equals(other.allvotes))
+			return false;
+		if (powers == null) {
+			if (other.powers != null)
+				return false;
+		} else if (!powers.equals(other.powers))
+			return false;
+		return true;
+	}
+
+	@Override
+	public String toString() {
+		return "CollectedVotes[" + allvotes + "," + powers + "]";
+	}
+
+}
Index: /voting/src/main/java/geniusweb/voting/VotingEvaluator.java
===================================================================
--- /voting/src/main/java/geniusweb/voting/VotingEvaluator.java	(revision 21)
+++ /voting/src/main/java/geniusweb/voting/VotingEvaluator.java	(revision 21)
@@ -0,0 +1,58 @@
+package geniusweb.voting;
+
+import com.fasterxml.jackson.annotation.JsonAutoDetect;
+import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
+import com.fasterxml.jackson.annotation.JsonSubTypes;
+import com.fasterxml.jackson.annotation.JsonTypeInfo;
+import com.fasterxml.jackson.annotation.JsonTypeInfo.As;
+
+import geniusweb.inform.Agreements;
+import geniusweb.voting.votingevaluators.LargestAgreement;
+import geniusweb.voting.votingevaluators.LargestAgreementsLoop;
+
+/**
+ * Evaluates the {@link CollectedVotes}, determining the agreements and if the
+ * negotiation should continue.
+ * 
+ * Implementations should be immutable and not serialize internal variables (eg
+ * 
+ * @JsonIgnore them).
+ */
+@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE, isGetterVisibility = Visibility.NONE)
+@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = As.WRAPPER_OBJECT)
+@JsonSubTypes({ @JsonSubTypes.Type(value = LargestAgreementsLoop.class),
+		@JsonSubTypes.Type(value = LargestAgreement.class) })
+public interface VotingEvaluator {
+	/**
+	 * This function is the effective constructor. This mechanism serves several
+	 * purposes:
+	 * <ul>
+	 * <li>It defines the constructor at interface level, so that we can ensure
+	 * it's available and can call it given an instance,
+	 * <li>We can use a (typically blank) instance of this to make more
+	 * instances
+	 * <li>You can cache intermediate results in the object for caching
+	 * </ul>
+	 * 
+	 * @param votes the Votes made by parties. All active parties in the
+	 *              negotiation must be available, even if they did not vote, to
+	 *              ensure that {@link #isFinished()} can work properly.
+	 * 
+	 * @return new VotingEvaluation object containing the given votes.
+	 */
+	VotingEvaluator create(CollectedVotes votes);
+
+	/**
+	 * 
+	 * @return the agreements that is contained in the current available votes.
+	 *         The exact procedure varies with the implementation.
+	 */
+	Agreements getAgreements();
+
+	/**
+	 * 
+	 * @return true iff the negotiation is finished after taking the agreement
+	 *         returned by {@link #getAgreements()}
+	 */
+	boolean isFinished();
+}
Index: /voting/src/main/java/geniusweb/voting/votingevaluators/LargestAgreement.java
===================================================================
--- /voting/src/main/java/geniusweb/voting/votingevaluators/LargestAgreement.java	(revision 21)
+++ /voting/src/main/java/geniusweb/voting/votingevaluators/LargestAgreement.java	(revision 21)
@@ -0,0 +1,109 @@
+package geniusweb.voting.votingevaluators;
+
+import java.util.Collections;
+import java.util.Comparator;
+import java.util.HashSet;
+import java.util.Map;
+import java.util.Set;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonIgnore;
+
+import geniusweb.actions.PartyId;
+import geniusweb.inform.Agreements;
+import geniusweb.issuevalue.Bid;
+import geniusweb.voting.CollectedVotes;
+import geniusweb.voting.VotingEvaluator;
+
+/**
+ * Take the first possible agreement, and take the largest possible agreement.
+ * Stop after first agreement.
+ */
+public class LargestAgreement implements VotingEvaluator {
+	@JsonIgnore
+	private final CollectedVotes allVotes;
+
+	// caching
+	@JsonIgnore
+	private Agreements maxAgreements = null;
+
+	@JsonCreator
+	public LargestAgreement() {
+		this(new CollectedVotes(Collections.emptyMap(),
+				Collections.emptyMap()));
+	}
+
+	protected LargestAgreement(CollectedVotes votes) {
+		this.allVotes = votes;
+	}
+
+	@Override
+	public Agreements getAgreements() {
+		if (maxAgreements == null)
+			maxAgreements = collectVotes();
+		return maxAgreements;
+	}
+
+	@Override
+	public boolean isFinished() {
+		HashSet<PartyId> parties = new HashSet<PartyId>(
+				allVotes.getVotes().keySet());
+		parties.removeAll(getAgreements().getMap().keySet());
+		return parties.size() < 2;
+	}
+
+	@Override
+	public VotingEvaluator create(CollectedVotes votes) {
+		return new LargestAgreementsLoop(votes);
+	}
+
+	/**
+	 * @return the agreements that were reached from the given votes, using the
+	 *         greedy algorithm picking the largets votesets.
+	 */
+	protected Agreements collectVotes() {
+		Agreements agreement = new Agreements();
+
+		Map<Bid, Set<PartyId>> agrees = allVotes.getMaxAgreements();
+		if (agrees.isEmpty())
+			return agreement;// none
+
+		// find the best one
+		Bid maxbid = agrees.keySet().stream()
+				.max(Comparator.comparingInt(bid -> agrees.get(bid).size()))
+				.get();
+		agreement = agreement.with(maxbid, agrees.get(maxbid));
+		return agreement;
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result
+				+ ((allVotes == null) ? 0 : allVotes.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		LargestAgreement other = (LargestAgreement) obj;
+		if (allVotes == null) {
+			if (other.allVotes != null)
+				return false;
+		} else if (!allVotes.equals(other.allVotes))
+			return false;
+		return true;
+	}
+
+	@Override
+	public String toString() {
+		return "LargestAgreement";
+	}
+}
Index: /voting/src/main/java/geniusweb/voting/votingevaluators/LargestAgreementsLoop.java
===================================================================
--- /voting/src/main/java/geniusweb/voting/votingevaluators/LargestAgreementsLoop.java	(revision 21)
+++ /voting/src/main/java/geniusweb/voting/votingevaluators/LargestAgreementsLoop.java	(revision 21)
@@ -0,0 +1,120 @@
+package geniusweb.voting.votingevaluators;
+
+import java.util.Collections;
+import java.util.Comparator;
+import java.util.HashSet;
+import java.util.Map;
+import java.util.Set;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonIgnore;
+
+import geniusweb.actions.PartyId;
+import geniusweb.inform.Agreements;
+import geniusweb.issuevalue.Bid;
+import geniusweb.voting.CollectedVotes;
+import geniusweb.voting.VotingEvaluator;
+
+/**
+ * {@link #getAgreements()} collects all possible {@link Agreements}. We're
+ * finished only when {@link #getAgreements()} covers all except possibly 1
+ * party.
+ * 
+ * The agreements is a list of {@link Bid}s and a maximum-sized list of
+ * {@link PartyId}s that placed a satisfied vote for that bid. maximum-sized
+ * means that there is no larger subset of votes for that bid. There may be
+ * other subsets of equal size for the bid. If there are no agreements at all
+ * for a bid, the bid is not placed in the map.
+ * 
+ */
+public class LargestAgreementsLoop implements VotingEvaluator {
+	@JsonIgnore
+	private final CollectedVotes allVotes;
+
+	// caching
+	@JsonIgnore
+	private Agreements maxAgreements = null;
+
+	@JsonCreator
+	public LargestAgreementsLoop() {
+		this(new CollectedVotes(Collections.emptyMap(),
+				Collections.emptyMap()));
+	}
+
+	protected LargestAgreementsLoop(CollectedVotes votes) {
+		this.allVotes = votes;
+	}
+
+	@Override
+	public Agreements getAgreements() {
+		if (maxAgreements == null)
+			maxAgreements = collectAgreements();
+		return maxAgreements;
+	}
+
+	@Override
+	public boolean isFinished() {
+		HashSet<PartyId> parties = new HashSet<PartyId>(
+				allVotes.getVotes().keySet());
+		parties.removeAll(getAgreements().getMap().keySet());
+		return parties.size() < 2;
+	}
+
+	@Override
+	public VotingEvaluator create(CollectedVotes votes) {
+		return new LargestAgreementsLoop(votes);
+	}
+
+	/**
+	 * @return the agreements that were reached from the given votes, using the
+	 *         greedy algorithm picking the largets votesets.
+	 */
+	protected Agreements collectAgreements() {
+		CollectedVotes remainingvotes = allVotes;
+		Agreements newagreements = new Agreements();
+		while (true) {
+			Map<Bid, Set<PartyId>> agrees = remainingvotes.getMaxAgreements();
+			if (agrees.isEmpty())
+				break;
+			// find the best one
+			Bid maxbid = agrees.keySet().stream()
+					.max(Comparator.comparingInt(bid -> agrees.get(bid).size()))
+					.get();
+			Set<PartyId> maxparties = agrees.get(maxbid);
+			newagreements = newagreements.with(maxbid, maxparties);
+			remainingvotes = remainingvotes.without(maxparties);
+		}
+		return newagreements;
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result
+				+ ((allVotes == null) ? 0 : allVotes.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		LargestAgreementsLoop other = (LargestAgreementsLoop) obj;
+		if (allVotes == null) {
+			if (other.allVotes != null)
+				return false;
+		} else if (!allVotes.equals(other.allVotes))
+			return false;
+		return true;
+	}
+
+	@Override
+	public String toString() {
+		return "LargestAgreementsLoop";
+	}
+}
Index: /voting/src/test/java/geniusweb/voting/CollectedVotesTest.java
===================================================================
--- /voting/src/test/java/geniusweb/voting/CollectedVotesTest.java	(revision 21)
+++ /voting/src/test/java/geniusweb/voting/CollectedVotesTest.java	(revision 21)
@@ -0,0 +1,246 @@
+package geniusweb.voting;
+
+import static org.junit.Assert.assertEquals;
+import static org.mockito.Mockito.mock;
+
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.Iterator;
+import java.util.List;
+import java.util.Map;
+import java.util.Set;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import geniusweb.actions.PartyId;
+import geniusweb.actions.Vote;
+import geniusweb.actions.Votes;
+import geniusweb.issuevalue.Bid;
+import tudelft.utilities.junit.GeneralTests;
+
+public class CollectedVotesTest extends GeneralTests<CollectedVotes> {
+
+	private final Bid bidA = mock(Bid.class), bidB = mock(Bid.class);
+	private final Bid a = mock(Bid.class), b = mock(Bid.class),
+			c = mock(Bid.class), d = mock(Bid.class);
+	private final PartyId party1 = new PartyId("party1");
+	private final PartyId party2 = new PartyId("party2");
+	private final PartyId party3 = new PartyId("party3");
+	private final PartyId party4 = new PartyId("party4");
+
+	private final PartyId partyP = new PartyId("partyP");
+	private final PartyId partyQ = new PartyId("partyQ");
+	private final PartyId partyR = new PartyId("partyR");
+
+	private final Vote votePA2 = new Vote(partyP, bidA, 2);
+	private final Vote voteQA2 = new Vote(partyQ, bidA, 2);
+	private final Vote voteQB3 = new Vote(partyQ, bidB, 3);
+	private final Vote voteQB2 = new Vote(partyQ, bidB, 2);
+	private final Vote voteRA2 = new Vote(partyR, bidA, 2);
+	private final Vote voteRA3 = new Vote(partyR, bidA, 3);
+	private final Vote voteRA4 = new Vote(partyR, bidA, 4);
+	private final Vote voteRB2 = new Vote(partyR, bidB, 2);
+
+	private Map<PartyId, Integer> allpowers = new HashMap<>();
+
+	private CollectedVotes cv1 = new CollectedVotes(Collections.emptyMap(),
+			Collections.emptyMap());
+	private CollectedVotes cv1a = new CollectedVotes(Collections.emptyMap(),
+			Collections.emptyMap());
+
+	private Votes votes = new Votes(partyP, Arrays.asList(votePA2));
+	private CollectedVotes cv2 = new CollectedVotes(
+			Collections.singletonMap(partyP, votes),
+			Collections.singletonMap(partyP, 1));
+
+	@Override
+	public List<List<CollectedVotes>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(cv1, cv1a), Arrays.asList(cv2));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("CollectedVotes.\\{\\}.*\\{\\}.*",
+				"CollectedVotes.\\{partyP=Votes.*Vote.partyP,Mock.*,2.*\\}.*\\{partyP=1\\}.*");
+	}
+
+	@Before
+	public void before() {
+		allpowers.put(partyP, 1);
+		allpowers.put(partyQ, 1);
+		allpowers.put(partyR, 1);
+	}
+
+	@Test
+	public void testGetAllBids() {
+		Map<PartyId, Votes> allvotes = new HashMap<>();
+		allvotes.put(partyP, new Votes(partyP, Arrays.asList(votePA2)));
+		allvotes.put(partyQ,
+				new Votes(partyQ, Arrays.asList(voteQA2, voteQB3)));
+
+		Map<Bid, Set<Vote>> allbids = new CollectedVotes(allvotes, allpowers)
+				.getAllBids();
+		assertEquals(2, allbids.size());
+		assertEquals(new HashSet<>(Arrays.asList(votePA2, voteQA2)),
+				allbids.get(bidA));
+		assertEquals(new HashSet<>(Arrays.asList(voteQB3)), allbids.get(bidB));
+	}
+
+	@Test
+	public void testGetMaxSubset2() {
+		Set<Vote> votes = new HashSet<>(Arrays.asList(votePA2, voteQA2));
+		CollectedVotes cv = new CollectedVotes(Collections.emptyMap(),
+				allpowers);
+		Set<PartyId> parties = cv.getMaxPowerGroup(votes);
+		assertEquals(new HashSet<>(Arrays.asList(partyP, partyQ)), parties);
+	}
+
+	@Test
+	public void testGetMaxSubset3() {
+		Set<Vote> votes = new HashSet<>(
+				Arrays.asList(votePA2, voteQA2, voteRA4));
+		CollectedVotes cv = new CollectedVotes(Collections.emptyMap(),
+				allpowers);
+
+		Set<PartyId> parties = cv.getMaxPowerGroup(votes);
+		// party R wants 4 votes so we can't satisfy
+		assertEquals(new HashSet<>(Arrays.asList(partyP, partyQ)), parties);
+	}
+
+	@Test
+	public void testGetMaxSubset3b() {
+		Set<Vote> votes = new HashSet<>(
+				Arrays.asList(votePA2, voteQA2, voteRA3));
+		CollectedVotes cv = new CollectedVotes(Collections.emptyMap(),
+				allpowers);
+		Set<PartyId> parties = cv.getMaxPowerGroup(votes);
+		// party R wants 4 votes so we can't satisfy
+		assertEquals(new HashSet<>(Arrays.asList(partyP, partyQ, partyR)),
+				parties);
+	}
+
+	@Test
+	public void testGetMaxAgreements() {
+		Map<PartyId, Votes> allvotes = new HashMap<>();
+		allvotes.put(partyP, new Votes(partyP, Arrays.asList(votePA2)));
+		allvotes.put(partyQ,
+				new Votes(partyQ, Arrays.asList(voteQA2, voteQB2)));
+		allvotes.put(partyR,
+				new Votes(partyR, Arrays.asList(voteRA4, voteRB2)));
+
+		Map<Bid, Set<PartyId>> allagrees = new CollectedVotes(allvotes,
+				allpowers).getMaxAgreements();
+		assertEquals(new HashSet<>(Arrays.asList(partyP, partyQ)),
+				allagrees.get(bidA));
+		assertEquals(new HashSet<>(Arrays.asList(partyQ, partyR)),
+				allagrees.get(bidB));
+
+	}
+
+	@Test
+	public void testGetNoAgreements() {
+		Map<PartyId, Votes> allvotes = new HashMap<>();
+		allvotes.put(partyP, new Votes(partyP, Arrays.asList(votePA2)));
+		Map<Bid, Set<PartyId>> allagrees = new CollectedVotes(allvotes,
+				allpowers).getMaxAgreements();
+		assertEquals(Collections.emptyMap(), allagrees);
+
+	}
+
+	@Test
+	public void getConsensusGroupsTest() {
+		CollectedVotes cv = new CollectedVotes(Collections.emptyMap(),
+				allpowers);
+
+		Set<Set<PartyId>> consensus = cv
+				.getConsensusGroups(Arrays.asList(votePA2, voteQA2));
+		// should give 1 solution: both parties join in.
+		System.out.println(consensus);
+		assertEquals(1, consensus.size());
+		assertEquals(2, consensus.iterator().next().size());
+	}
+
+	@Test
+	public void getConsensusGroupsTestPQR() {
+		CollectedVotes cv = new CollectedVotes(Collections.emptyMap(),
+				allpowers);
+
+		Set<Set<PartyId>> consensus = cv
+				.getConsensusGroups(Arrays.asList(votePA2, voteQA2, voteRA4));
+		// should give 1 solution: P and Q join in. 4 is unreachable.
+		System.out.println(consensus);
+		assertEquals(1, consensus.size());
+		assertEquals(2, consensus.iterator().next().size());
+	}
+
+	@Test
+	public void getConsensusGroupsTestPQR2() {
+		CollectedVotes cv = new CollectedVotes(Collections.emptyMap(),
+				allpowers);
+
+		Set<Set<PartyId>> consensus = cv
+				.getConsensusGroups(Arrays.asList(votePA2, voteQA2, voteRA2));
+		// should give 4 solutions: P+Q, P+R, Q+R and P+Q+R
+		System.out.println(consensus);
+		assertEquals(4, consensus.size());
+	}
+
+	@Test
+	public void getConsensusGroupsTestRExtraPower() {
+		// give R extra power to reach the 4 if other 2 join
+		allpowers = new HashMap<>();
+		allpowers.put(partyP, 1);
+		allpowers.put(partyQ, 1);
+		allpowers.put(partyR, 2);
+
+		CollectedVotes cv = new CollectedVotes(Collections.emptyMap(),
+				allpowers);
+
+		Set<Set<PartyId>> consensus = cv
+				.getConsensusGroups(Arrays.asList(votePA2, voteQA2, voteRA4));
+		// should give solutions P+Q and P+Q+R
+		System.out.println(consensus);
+		assertEquals(2, consensus.size());
+		Iterator<Set<PartyId>> it = consensus.iterator();
+		assertEquals(2, it.next().size());
+		assertEquals(3, it.next().size());
+	}
+
+	@Test
+	public void testWith() {
+		Map<PartyId, Votes> allvotes = new HashMap<>();
+		allvotes.put(partyP, new Votes(partyP, Arrays.asList(votePA2)));
+		CollectedVotes cv = new CollectedVotes(allvotes, allpowers);
+		assertEquals(1, cv.getVotes().keySet().size());
+		cv = cv.with(new Votes(partyQ, Arrays.asList(voteQA2)), 2);
+		assertEquals(2, cv.getVotes().keySet().size());
+	}
+
+	@Test
+	public void testWithout() {
+		Map<PartyId, Votes> allvotes = new HashMap<>();
+		allvotes.put(partyP, new Votes(partyP, Arrays.asList(votePA2)));
+		allvotes.put(partyQ,
+				new Votes(partyQ, Arrays.asList(voteQA2, voteQB2)));
+		allvotes.put(partyR,
+				new Votes(partyR, Arrays.asList(voteRA4, voteRB2)));
+
+		// give R extra power to reach the 4 if other 2 join
+		allpowers = new HashMap<>();
+		allpowers.put(partyP, 1);
+		allpowers.put(partyQ, 1);
+		allpowers.put(partyR, 2);
+
+		CollectedVotes cv = new CollectedVotes(allvotes, allpowers);
+
+		assertEquals(3, cv.getVotes().size());
+		cv = cv.without(new HashSet<>(Arrays.asList(partyP, partyQ)));
+		assertEquals(1, cv.getVotes().size());
+		assertEquals(1, cv.getPowers().size());
+
+	}
+
+}
